﻿using System.Diagnostics;
using System.Linq;
using System.Security.Cryptography;
using PasswordCrackerCentralized.model;
using PasswordCrackerCentralized.util;
using System;
using System.Collections.Generic;
using System.IO;

namespace PasswordCrackerCentralized
{
    public class Cracking
    {
        /// <summary>
        /// Runs the password cracking algorithm
        /// </summary>
        public void RunCracking()
        {
            Stopwatch stopwatch = Stopwatch.StartNew();
            List<UserInfo> userInfos = PasswordFileHandler.ReadPasswordFile("passwords.txt");
            var result = ReadDictionary("webster-dictionary.txt").Variations().AsParallel().Encrypt().Check(userInfos);
            
            //var res = from word in ReadDictionary("webster-dictionary.txt").Variations()
            //          where EncryptAndCheck(word)
            //          select 
                      
            List<UserInfoClearText> list = result.ToList();
            stopwatch.Stop();
            Console.WriteLine("Time elapsed: {0}", stopwatch.Elapsed);
            Console.WriteLine("Found: " + String.Join(", ", list));
        }

        public static IEnumerable<String> ReadDictionary(String filename)
        {
            using (FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read))
            using (StreamReader dictionary = new StreamReader(fs))
            {
                while (!dictionary.EndOfStream)
                {
                    String dictionaryEntry = dictionary.ReadLine();
                    yield return dictionaryEntry;
                }
            }
        }
    }
}